// img base64 估算大小
// console.log(imgBase64ToKb("data:image/jpg;base64,iVBOT578r/3798vPP/98umUjEAgEAoFAuCApEgRh8ujRowvTLQiBQOg//j+LjgP2tHs7pQAAElFTkSuQmCC"));
function imgBase64ToKb(base64_str) {
  var eqTagIndex = base64_str.indexOf("=");
  var tmp = eqTagIndex != -1 ? base64_str.substring(0, eqTagIndex) : base64_str;
  return base64ToKb(tmp);
}
// console.log(imgBase64To("data:image/jpg;base64,iVBOT578r/3798vPP/98umUjEAgEAoFAuCApEgRh8ujRowvTLQiBQOg//j+LjgP2tHs7pQAAElFTkSuQmCC"));
// base64 估算大小
function base64ToKb(base64_str) {
  var strLen = base64_str.length;
  var fileSize = strLen - (strLen / 8) * 2;
  return fileSize / 10240;
}

function removeImgBase64DataUri(base64_str) {
  if (!base64_str) return null;
  base64_str = base64_str.replace(/^data:image\/\w+;base64,/, "");
  return base64_str;
}

// JS实现excel表头字母和数字的转换
// console.log(numToString(1));
function numToString(numm) {
  var stringArray = [];
  stringArray.length = 0;
  var numToStringAction = function (nnum) {
    var num = nnum - 1;
    var a = parseInt(num / 26);
    var b = num % 26;
    stringArray.push(String.fromCharCode(64 + parseInt(b + 1)));
    if (a > 0) {
      numToStringAction(a);
    }
  };
  numToStringAction(numm);
  return stringArray.reverse().join("");
}

// excel列转下标  A =》 1
// console.log(stringTonum('A'));
function stringTonum(a) {
  var str = a.toLowerCase().split("");
  var num = 0;
  var al = str.length;
  var getCharNumber = function (charx) {
    return charx.charCodeAt() - 96;
  };
  var numout = 0;
  var charnum = 0;
  for (var i = 0; i < al; i++) {
    charnum = getCharNumber(str[i]);
    numout += charnum * Math.pow(26, al - i - 1);
  }
  return numout;
}

function delSpace(str) {
  str = str.replace(/\r\n/g, "");
  str = str.replace(/\n/g, "");
  return str;
}

function isValidFileName(fileName) {
  //校验文件名
  //文件名校验
  // let fileNameReg1 = /^((\(|（)\d+(\)|）))|(\s*\d+\s*)$/;
  // let fileNameReg2 = /^(\s*\d+\s*-\s*)+\d+\s*$/;
  // let fileNameReg3 = new RegExp('[\\\\/:*?"<>|]');
  // let fileNameReg4 = /(\s+)|[\?\*:"\<\>\\\/\|]/g;
  var reg = new RegExp('[\\\\/:*?"<>|]');
  if (reg.test(fileName)) {
    message = '不能包含【\\\\/:*?"<>|】这些非法字符!';
    console.log(message);
    return false;
  } else {
    return true;
  }
}

// win 文件名
// 1、允许文件或者文件夹名称不得超过255个字符。
// 2、文件名除了开头之外任何地方都可以使用空格。
// 3、文件名中不能有下列符号：“？”、“、”、“/”、“╲”、“*”、“<”、“>”、“|”。
// 4、Windows文件名不区分大小写，但在显示时可以保留大小写格式。
function delFileName(str) {
  str = delSpace(str);
  str = str.replace(/[\\\\/:*?"<>|]/g, "");
  str = str.substring(0, str.length > 255 ? str.length : 255);
  return str;
}

// 文本字数统计、字符串字节数计算
function CountChineseCharacters(Words) {
  var W = new Object();
  var Result = new Array();
  var iNumwords = 0;
  var sNumwords = 0;
  var sTotal = 0;
  var iTotal = 0;
  var eTotal = 0;
  var otherTotal = 0;
  var bTotal = 0;
  var inum = 0;
  for (i = 0; i < Words.length; i++) {
    var c = Words.charAt(i);
    if (c.match(/[\u4e00-\u9fa5]/)) {
      if (isNaN(W[c])) {
        iNumwords++;
        W[c] = 1;
      }
      iTotal++;
    }
  }
  for (i = 0; i < Words.length; i++) {
    var c = Words.charAt(i);
    if (c.match(/[^\x00-\xff]/)) {
      if (isNaN(W[c])) {
        sNumwords++;
      }
      sTotal++;
    } else {
      eTotal++;
    }
    if (c.match(/[0-9]/)) {
      inum++;
    }
  }
  return {
    hanzi: iTotal, //汉字
    zishu: inum + iTotal, //字数
    biaodian: sTotal - iTotal, //标点(全角)
    zimu: eTotal - inum, //字母
    shuzi: inum, //数字
    zifu: iTotal * 2 + (sTotal - iTotal) * 2 + eTotal //共计
  };
}

//str  是否json字符串
function isJSON(str) {
  if (typeof str == "string") {
    try {
      var obj = JSON.parse(str);
      if (typeof obj == "object" && obj) {
        return true;
      } else {
        return false;
      }
    } catch (e) {
      // console.log('error：'+str+'!!!'+e);
      return false;
    }
  } else {
    return false;
  }
}

let output = {
  imgBase64ToKb: imgBase64ToKb,
  base64ToKb: base64ToKb,
  removeImgBase64DataUri: removeImgBase64DataUri,
  numToString: numToString,
  stringTonum: stringTonum,
  delSpace: delSpace,
  isValidFileName: isValidFileName,
  delFileName: delFileName,
  CountChineseCharacters: CountChineseCharacters,
  isJSON: isJSON
};
// export default output;
module.exports = output;
