const path = require("path");

const serverConfig = {
  entry: "./lib/index.js",
  target: "node",
  output: {
    filename: "node.something.js",
    path: path.resolve(__dirname, "dist"),
    library: {
      name: "something",
      type: "umd"
    },
    // libraryExport: "default",
    globalObject: "this"
  }
};

const clientConfig = {
  entry: "./lib/index.js",
  target: ["web", "es5"],
  output: {
    filename: "something.js",
    path: path.resolve(__dirname, "dist"),
    library: {
      name: "something",
      type: "umd"
    },
    libraryExport: "default",
    globalObject: "this"
  },
  module: {
    // rules: [{
    //     test: /.js$/,
    //     enforce: 'post', // post-loader处理
    //     loader: 'es3ify-loader'
    // }]
    rules: [
      {
        test: /\.js$/,
        exclude: /node_modules/,
        use: {
          loader: "babel-loader"
        }
      }
    ]
  },
  externals: {}
};

module.exports = [serverConfig, clientConfig];
